Bug 1703284 - Review Request: nbd-runner - one nbd service for distributed storages
Summary: Review Request: nbd-runner - one nbd service for distributed storages
Keywords:
Status: ON_QA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR
TreeView+ depends on / blocked
 
Reported: 2019-04-26 02:09 UTC by Xiubo Li
Modified: 2019-07-30 01:14 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Xiubo Li 2019-04-26 02:09:32 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/xiubli/nbd-runner/fedora-30-x86_64/00888156-nbd-runner/nbd-runner.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/xiubli/nbd-runner/fedora-30-x86_64/00888156-nbd-runner/nbd-runner-0.3-rc1.fc30.src.rpm
Description: This is one server daemon in userspace for Network Block Device for Distributed Storages, such as Gluster, Ceph, Azure, etc. 
Fedora Account System Username: xiubli

Comment 1 Robert-André Mauchin 2019-05-01 20:56:53 UTC
 - Group: is not used in Fedora

 - Should just be 1:

Release:       rc1%{?dist}

 It's not a rc.

 - Buildroot is not used anymore

BuildRoot:     %(mktemp -udp %{_tmppath}/%{name}-%{version}%)

 - Not needed:

ExclusiveOS:   Linux

 - The Source: must be a URL

Source:        https://github.com/gluster/nbd-runner/archive/v%{version}/%{name}-%{version}.tar.gz

 - Please split you BuildRequires And Requires: one per line 

 - Add gcc as a BuildRequires

 - No: %global debug_package %{nil}

If your package is not generating debug symbols, you need to fimd why and fix it.

 - Use %make_build first:

%build
./autogen.sh
%configure %{?_without_tirpc} %{?_without_gluster}
%make_build

 - %{__make} DESTDIR=%{buildroot} install → %make_install

 - license files must be included with %license, not %doc:

%license COPYING-GPLV2 COPYING-LGPLV3

 - You must add the Release info in your %changelog entry:

* Wed Apr 24 2019 Xiubo Li <xiubli@redhat.com> - 0.3-1

 - Not needed this is the default already:

%global _hardened_build 1



You'll also need to find a sponsor. Read https://fedoraproject.org/wiki/Join_the_package_collection_maintainers?rd=PackageMaintainers/Join and https://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group

Also you need to sign the CLA on your FAS page.

Comment 2 Xiubo Li 2019-05-05 08:03:47 UTC
Update the src rpms and spec:

Spec URL: https://github.com/lxbsz/packages/blob/master/nbd-runner.spec
SRPM URL: https://github.com/lxbsz/packages/blob/master/nbd-runner-0.3-1.fc29.src.rpm
Description: This is one server daemon in userspace for Network Block Device for Distributed Storages, such as Gluster, Ceph, Azure, etc. This is my first package and seeking a sponsor.
Fedora Account System Username: xiubli

Comment 3 Xiubo Li 2019-05-05 08:05:53 UTC
(In reply to Robert-André Mauchin from comment #1)

@Robert-André Mauchin

Thanks very much for your detail info about the spec file.

Update it and I am still seeking for a sponsor.

Thanks.
BRs

Comment 4 Robert-André Mauchin 2019-06-05 19:04:50 UTC
It seems autoreconf fails

autogen.sh: start libtoolize to get ltmain.sh
libtoolize: putting auxiliary files in '.'.
libtoolize: copying file './ltmain.sh'
libtoolize: putting macros in AC_CONFIG_MACRO_DIRS, 'm4'.
libtoolize: copying file 'm4/libtool.m4'
libtoolize: copying file 'm4/ltoptions.m4'
libtoolize: copying file 'm4/ltsugar.m4'
libtoolize: copying file 'm4/ltversion.m4'
libtoolize: copying file 'm4/lt~obsolete.m4'
autogen.sh: reconfigure with autoreconf
BUILDSTDERR: autoreconf: Entering directory `.'
BUILDSTDERR: autoreconf: configure.ac: not using Gettext
BUILDSTDERR: autoreconf: running: aclocal -I m4 --force -I m4
BUILDSTDERR: sh: git: command not found
BUILDSTDERR: configure.ac:122: error: AC_INIT should be called with package and version arguments
BUILDSTDERR: /usr/share/aclocal-1.16/init.m4:29: AM_INIT_AUTOMAKE is expanded from...
BUILDSTDERR: configure.ac:122: the top level
BUILDSTDERR: autom4te: /usr/bin/m4 failed with exit status: 1
BUILDSTDERR: aclocal: error: echo failed with exit status: 1
BUILDSTDERR: autoreconf: aclocal failed with exit status: 1
autogen.sh: autoreconf has failed (1), let's do it manually
autogen.sh: configure nbd-runner-0.3
BUILDSTDERR: sh: git: command not found
BUILDSTDERR: configure.ac:122: error: AC_INIT should be called with package and version arguments
BUILDSTDERR: /usr/share/aclocal-1.16/init.m4:29: AM_INIT_AUTOMAKE is expanded from...
BUILDSTDERR: configure.ac:122: the top level
BUILDSTDERR: autom4te: /usr/bin/m4 failed with exit status: 1
BUILDSTDERR: aclocal: error: echo failed with exit status: 1
BUILDSTDERR: error: Bad exit status from /var/tmp/rpm-tmp.97vMHt (%build)
BUILDSTDERR:     Bad exit status from /var/tmp/rpm-tmp.97vMHt (%build)

even with git as a BR it fails too.

You need to create a VERSION file manually:

%build
echo v%{version} > VERSION

 - Build still has error afterwards:

checking for suffix of executables... 
BUILDSTDERR: checking whether we are cross compiling... configure: error: in `/builddir/build/BUILD/nbd-runner-0.3':
BUILDSTDERR: configure: error: cannot run C compiled programs.
BUILDSTDERR: If you meant to cross compile, use `--host'.
BUILDSTDERR: See `config.log' for more details

 We need to redefine cflags to use fPIC:

./autogen.sh
export CFLAGS="%build_cflags -fPIC"
export CPPFLAGS="%build_cxxflags -fPIC"
%configure %{?_without_tirpc} %{?_without_gluster} %{?_without_azblk}
sed -i "/CLFAGS/d" configure
%make_build

 - The build still fails because there is no library generated in /usr/lib64/nbd-runner/:

+ find /builddir/build/BUILDROOT/nbd-runner-0.3-1.fc31.x86_64/usr/lib64/nbd-runner/ -name '*.a' -delete
BUILDSTDERR: find: '/builddir/build/BUILDROOT/nbd-runner-0.3-1.fc31.x86_64/usr/lib64/nbd-runner/': No such file or directory

 It seems they are only available in the master branch, not the 0.3 release

Comment 5 Robert-André Mauchin 2019-06-05 19:10:42 UTC
You archive of version 0.3 in the SRPM does not correspond to the version 0.3 as downloaded on Github. If you want to package a GIT snapshot, don't use version 0.3


%global commit          e174ebaa282a681b932b6b8790851b78da0168d7
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global snapshotdate    20190605

[…]

Version:       0.3
Release: 1.%{snapshotdate}git%{shortcommit}%{?dist}
URL:           https://github.com/gluster/nbd-runner.git

Source0: https://github.com/gluster/%{name}/archive/%{commit}/%{name}-%{shortcommit}.tar.gz

[…]

%autosetup -p 1 -n %{name}-%{commit}

Comment 6 Xiubo Li 2019-06-06 05:41:30 UTC
(In reply to Robert-André Mauchin from comment #5)
> You archive of version 0.3 in the SRPM does not correspond to the version
> 0.3 as downloaded on Github. If you want to package a GIT snapshot, don't
> use version 0.3
> 
> 
> %global commit          e174ebaa282a681b932b6b8790851b78da0168d7
> %global shortcommit     %(c=%{commit}; echo ${c:0:7})
> %global snapshotdate    20190605
> 
> […]
> 
> Version:       0.3
> Release: 1.%{snapshotdate}git%{shortcommit}%{?dist}
> URL:           https://github.com/gluster/nbd-runner.git
> 
> Source0:
> https://github.com/gluster/%{name}/archive/%{commit}/%{name}-%{shortcommit}.
> tar.gz
> 
> […]
> 
> %autosetup -p 1 -n %{name}-%{commit}

@Robert-André Mauchin

Thanks very much for you detail reply.

Fixed them all.

For the v0.4 version we have supported the Gluster and Azure handlers.

Update the srpm and spec:

Spec URL: https://github.com/lxbsz/packages/blob/master/nbd-runner.spec
SRPM URL: https://github.com/lxbsz/packages/blob/master/nbd-runner-0.4-0.fc29.src.rpm
Description: This is one server daemon in userspace for Network Block Device for Distributed Storages, such as Gluster, Ceph, Azure, etc. This is my first package and seeking a sponsor.
Fedora Account System Username: xiubli


# rpmlint nbd-runner-0.4-0.fc29.x86_64.rpm nbd-runner-debuginfo-0.4-0.fc29.x86_64.rpm nbd-runner-debugsource-0.4-0.fc29.x86_64.rpm 
3 packages and 0 specfiles checked; 0 errors, 0 warnings.
# 


Thanks.
BRs
Xiubo

Comment 7 Robert-André Mauchin 2019-06-07 15:04:31 UTC
 - License is LGPLv3+ or GPLv2 See https://github.com/gluster/nbd-runner#license

License: LGPLv3+ or GPLv2

Package approved. Please fix the aforementioned issue before import.




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GPL (v2) (with incorrect FSF
     address)", "Expat License Apache License (v2.0)", "Apache License
     (v2.0)", "ISC License". 39 files have unknown license. Detailed output
     of licensecheck in /home/bob/packaging/review/nbd-runner/review-nbd-
     runner/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Package should not use obsolete m4 macros
     Note: Some obsoleted macros found, see the attachment.
     See: https://fedorahosted.org/FedoraReview/wiki/AutoTools
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nbd-runner-0.4-0.fc31.x86_64.rpm
          nbd-runner-debuginfo-0.4-0.fc31.x86_64.rpm
          nbd-runner-debugsource-0.4-0.fc31.x86_64.rpm
          nbd-runner-0.4-0.fc31.src.rpm
4 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 8 Xiubo Li 2019-06-10 12:20:53 UTC
(In reply to Robert-André Mauchin from comment #7)
>  - License is LGPLv3+ or GPLv2 See
> https://github.com/gluster/nbd-runner#license
> 
> License: LGPLv3+ or GPLv2
> 
> Package approved. Please fix the aforementioned issue before import.
> 
> 
> 
> 
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> [ ] = Manual review needed
> 
> 
> ===== MUST items =====
> 
> C/C++:
> [x]: Package does not contain kernel modules.
> [x]: Package contains no static executables.
> [x]: Development (unversioned) .so files in -devel subpackage, if present.
>      Note: Unversioned so-files in private %_libdir subdirectory (see
>      attachment). Verify they are not in ld path.
> [x]: If your application is a C or C++ application you must list a
>      BuildRequires against gcc, gcc-c++ or clang.
> [x]: Header files in -devel subpackage, if present.
> [x]: Package does not contain any libtool archives (.la)
> [x]: Rpath absent or only used for internal libs.
> 
> Generic:
> [x]: Package is licensed with an open-source compatible license and meets
>      other legal requirements as defined in the legal section of Packaging
>      Guidelines.
> [!]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses
>      found: "Unknown or generated", "GPL (v2) (with incorrect FSF
>      address)", "Expat License Apache License (v2.0)", "Apache License
>      (v2.0)", "ISC License". 39 files have unknown license. Detailed output
>      of licensecheck in /home/bob/packaging/review/nbd-runner/review-nbd-
>      runner/licensecheck.txt

@Robert-André Mauchin

Thanks very much for you detail reply again, fixed the License and the using obsolete m4 macros issues.

Update the srpm and spec:

Spec URL: https://copr-be.cloud.fedoraproject.org/results/xiubli/nbd-runner/fedora-30-x86_64/00929528-nbd-runner/nbd-runner.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/xiubli/nbd-runner/fedora-30-x86_64/00929528-nbd-runner/nbd-runner-0.4-0.fc30.src.rpm


# rpmlint nbd-runner-0.4-0.fc29.x86_64.rpm nbd-runner-debuginfo-0.4-0.fc29.x86_64.rpm nbd-runner-debugsource-0.4-0.fc29.x86_64.rpm 
3 packages and 0 specfiles checked; 0 errors, 0 warnings.
# 

Thanks.
BRs

Comment 9 Michael S. 2019-07-15 10:39:24 UTC
I am going to sponsor Xiobu Li

Comment 10 Gwyn Ciesla 2019-07-16 13:46:28 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/nbd-runner

Comment 11 Xiubo Li 2019-07-18 08:43:28 UTC
@Michael, @Gwyn  Thanks very much :-)


The builds: https://koji.fedoraproject.org/koji/packageinfo?packageID=29705

Thanks.

Comment 12 Fedora Update System 2019-07-22 01:42:02 UTC
FEDORA-2019-46d28f682f has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-46d28f682f

Comment 13 Fedora Update System 2019-07-23 00:54:31 UTC
nbd-runner-0.4-2.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-46d28f682f

Comment 14 Fedora Update System 2019-07-25 13:35:48 UTC
FEDORA-2019-20aa23d56e has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-20aa23d56e

Comment 15 Fedora Update System 2019-07-25 13:38:10 UTC
FEDORA-2019-20aa23d56e has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-20aa23d56e

Comment 16 Fedora Update System 2019-07-26 01:47:33 UTC
nbd-runner-0.4-3.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-20aa23d56e

Comment 17 Fedora Update System 2019-07-30 01:14:56 UTC
nbd-runner-0.4-3.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.